import { IPlugin } from './plugins/base';
import { IRetryPolicy } from './plugins/retry';
export declare class BaseClient {
    protected _headers: {
        [k: string]: string | number | string[];
    };
    protected _plugins: (new () => IPlugin)[];
    auth(username: string, password: string): this;
    set(leader: string, value: string): this;
    set(leader: {
        [k: string]: string | number | string[];
    }): this;
    use(plugin: new () => IPlugin): this;
    timeout(ttl: number): this;
    retry(policy: number): this;
    retry(policy: IRetryPolicy): this;
    redirects(max_redirects: number): this;
}
