"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.redirect = void 0;
function redirect(max_redirects) {
    class RedirectPlugin {
        constructor() {
            this.redirects = 0;
        }
        async onError(req, err) {
            var _a, _b;
            if ((err.statusCode !== 300 && err.statusCode !== 301) ||
                !((_b = (_a = err === null || err === void 0 ? void 0 : err.response) === null || _a === void 0 ? void 0 : _a.headers) === null || _b === void 0 ? void 0 : _b.location) ||
                this.redirects >= max_redirects) {
                return;
            }
            this.redirects += 1;
            req.location(err.response.headers.location);
            return { retry: true };
        }
    }
    return RedirectPlugin;
}
exports.redirect = redirect;
